(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.haypo.fr.st/ $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
                Petite dmo changeant la police du mode texte 03h           
Ĵ
  Fichier ncessaire                                                      
                                                      
                                                                            
 -> 'ChangFnt.Fnt' : Police FNT v1.0 au format 16x8 pixel en noir & blanc   
*)

{$M 4096,0,4096}

uses Clavier,EcranTxt,GestFich,PolicTxt;

const
  TxtDemo = 'Voici une dmo montrant un nouveau police de caractre';

  AsciiDemo = Ord('D');
  MasqueB : array [0..7] of word= (128,64,32,16,8,4,2,1);

  { Positon et dimensions }
  ChrLarg = 8*2;             { Largeur du caractre }
  ChrHaut = 16;              { Hauteur du caractre }

  CadrX = 2; CadrY = 3;      { Coordonnes du cadre }
  CadrLarg = 80-CadrX-2;     { Largeur du cadre }
  CadrHaut = ChrHaut+2;     { Hauteur du cadre }

  TxtX = CadrX+ChrLarg+4;    { X du texte de dmonstration }
  TxtY = CadrY+2;            { Y du texte de dmonstration }

  LstX = CadrX+ChrLarg+5;    { X de la liste des caractres }
  LstY = TxtY+6+2;           { Y de la liste des caractres }
  LstLarg = CadrLarg-LstX-2;

var
  i,ix,iy, coul, max: byte;
  Caract: array[0..15] of byte;
  NomFich: String;

procedure DessineCaractere; begin
  LitCaract16x8 (AsciiDemo,Caract);

  for iy := 0 to 15 do begin
    for ix := 0 to 7 do begin
      if Caract[iy] and MasqueB[ix]=MasqueB[ix] then Coul := 10 else Coul := 0;
      EcriTxhc (CadrX+1+ix*2,CadrY+1+iy,2,'',coul);
    end;
  end;
end;

procedure DessineDecor; begin
  EffaceEcranTxt;

  { Dessine le cadre }
  CoulTxt := 9;
  DessineCadre (CadrX,CadrY,CadrLarg,CadrHaut,_DOUBLE,CoulTxt);
  EcriTxv (CadrX+ChrLarg+1,CadrY+1,CadrHaut-2,ChDLigneV);
  EcriTxh (CadrX+ChrLarg+2,LstY-2,CadrLarg-ChrLarg-3,ChDLigneH);
  EcriTx (CadrX+ChrLarg+1,CadrY,'');
  EcriTx (CadrX+ChrLarg+1,CadrY+CadrHaut-1,'');
  EcriTx (CadrX+ChrLarg+1,LstY-2,'');
  EcriTx (CadrX+CadrLarg-1,LstY-2,'');

  { Dessine le caractre }
  DessineCaractere;

  { Ecrit du texte }
  CoulTxt := 14;
  EcriTx (TxtX,TxtY+0,TxtDemo);
  EcriTx (TxtX,TxtY+1,'ABCDEFGHIJKLMNOPQRSTUVWXYZ');
  EcriTx (TxtX,TxtY+2,'abcdefghijklmnopqrstuvwxyz');
  EcriTx (TxtX,TxtY+3,'0123456789');

  { Affiche tous les caractres }
  i := 0; max := LstLarg;
  for iy := 0 to (256 div LstLarg)  do begin
    if iy=(256 div LstLarg) then max := 256 mod LstLarg;

    for ix := 0 to max-1 do begin
      EcriTx (LstX+ix,LstY+iy,chr(i));
      inc (i);
    end;
  end;
end;

begin
  InitModeTxt;

  EffaceEcranTxt;

  { Lit le nom de l'image dans le PSP ou le demande }
  NomFich := ParamStr(1);
  if NomFich='' then begin
    EffaceEcranTxt;
    EcriTcr ('Entrez le nom d''une police FNT (tapez entre pour choisir ChangFnt) : :',15);
    if not LitTxt (NomFich,13,15+3*16,14+1*16) then begin
      SauteLigne;
      Halt;
    end;

    if NomFich='' then NomFich := 'ChangFnt';
  end;

  AjouteExtNomFich (NomFich, 'fnt');
  if not FichierExistant (NomFich) then begin
    SauteLigne;
    EcriTcr ('Fichier '''+NomFich+''' de police introuvable !',12);
    SauteLigne;
    Halt;
  end;

  CurseurOff;

  DessineDecor;
  EcriTxc (-1,24,'<- Presser sur une touche ->',12); LitTouche;

  {--- La fonction magique ---}
  ChargeFnt (NomFich);
  {---------------------------}
  DessineCaractere;

  EcriTxc (-1,24,'<- Presser sur une touche pour FINIR ->',15);
  LitTouche;
end.
